module Db_Accessor
  class Base
    USER_MODEL        = 'User'
    APP_MODEL         = 'Application'
    ENGINE_MODEL      = 'Engine'
    ENGINE_DATA_MODEL = 'Engine_data'

    def self.validate_argument(given_param)
      resp = nil
      given_param.values.each do |v|
        if v.nil?
          resp = true
          break
        elsif v.is_a?(String) && v.empty?
          resp = true
          break
        else
          resp = false
        end
    end
      return resp
    end

    def self.return_response(code,msg)
      {code: code,message: msg}
    end

    def self.get_model_name(object_param)
      Object.const_get(object_param[:model_name])
    end

    def self.is_model?(param)
      model = [ USER_MODEL, APP_MODEL, ENGINE_MODEL, ENGINE_DATA_MODEL ]
      model.include?(param)
    end

    def self.valid_hash?(param)
      param.is_a?(Hash)
    end

    def self.valid_keys?(param,waited_keys)
      waited_keys.each do |k|
        if !(param.has_key?(k))
          return false
          break
        end
      end
      return true
    end

    def self.verify_keys(keys,attributes)
     keys.each do |k|
      if !(attributes.include?(k))
        return false
        break
      end
    end
    return true
    end

    def self.valid_object_columns?(model_name,content)
      engine_columns      = [:id,:name,:engine_conf,:application_id]
      engine_data_columns = [:id,:customer_id,:item_id,:preference,:engine_id]
      app_columns         = [:id,:name,:api_key,:url,:user_id]
      user_columns        = [:id,:login,:password,:firstname,:lastname,:gender,:email, :admin]

      keys = content.keys
      if model_name == "User"
        attributes = user_columns
      elsif model_name == "Application"
        attributes = app_columns
      elsif model_name == "Engine"
        attributes = engine_columns
      else
        attributes = engine_data_columns
      end


      verify_keys(keys,attributes)
    end
   def self.valid_class?(keys,columns,attributes)
     keys.each do |k|
      if columns.include?(k)
        if !(attributes[k].is_a?(String))
          return false
          break
        end
      else
        if !(attributes[k].is_a?(Fixnum))
          return false
          break
        end
      end
    end
    return true
  end

  def self.valid_attributes_values?(attributes)
    string_columns = [:login,:password,:firstname,:lastname,:gender,:email,:api_key,:name,:url,:engine_conf]
    fixnum_columns = [:user_id,:id,:engine_id,:application_id,:customer_id,:item_id,:preference]
    keys = attributes.keys
    valid_class?(keys,string_columns,attributes)
  end

end
end
