require_relative '../../../spec/feed/resources/environment'
require_relative '../base'

class DbAccessor::Reader < Db_Accessor::Base


  def self.simple_select(given_param)
    waited_keys = [:model_name,:action_on]
    if validate(given_param,waited_keys)
      result = get_model_name(given_param).where(deleted: false).send(given_param[:action_on])
      result.nil? ?  return_response(404,"Not found") : return_response(200,result)
    else
      return_response(404,"Not found")
    end
  rescue ActiveRecord::RecordNotFound => e
    return_response(404,"Not found")
  end

  def self.condition_select(given_param)
    waited_keys = [:model_name,:condition]
    if validate(given_param,waited_keys)
      result = get_model_name(given_param).where(given_param[:condition],deleted: false)
      ( result.nil? || result == []) ? return_response(404,"Not found") : return_response(200,result)
    else
      return_response(404,"Not found")
    end
  rescue ActiveRecord::RecordNotFound => e
    return_response(400,"Not found")
  end

  def self.select_by_id(given_param)
    waited_keys = [:model_name,:identifiers]
    if validate(given_param,waited_keys) && validate_id(given_param[:identifiers])
      model_name = get_model_name(given_param)
      result     = model_name.where(deleted: false).where(id: given_param[:identifiers])
      result.nil? ? return_response(404,"Not found") : return_response(200,result)
    else
      return_response(404,"Not found")
    end
  rescue ActiveRecord::RecordNotFound => e
    return_response(404,"Not found")
  end

  def self.linked_models_select(given_param)
    waited_keys = [:model_name,:condition,:models]
    if validate(given_param,waited_keys)
      model_name = get_model_name(given_param)
      condition  = given_param[:condition]
      models     = given_param[:models]
      result     = model_name.where(condition,deleted: false).first
      result.nil? ? return_response(404,"Not found") : return_response(200,result.send(models))
    else
      return_response(404,"Not found")
    end
  rescue ActiveRecord::RecordNotFound => e
    return_response(400,"Not found")
  end
  private ##################################################################

  def self.validate(param,waited_keys)
    valid_hash?(param) && valid_keys?(param,waited_keys) && !validate_argument(param) && is_model?(param[:model_name])
  end

  def self.validate_id(param)
    test_id = lambda do |param|
      param.each do |i|
        if !(i.is_a?(Fixnum))
          return false
          break
        end
      end
      return true
    end
    param.is_a?(Array) && test_id.call(param)
  end

end
