require_relative '../../../spec/feed/resources/environment'
require 'redis'

class Synchronizer

    def self.load
        apps  = Application.all
        users = User.all
        redis = Redis.current
        clean_redis(redis)
        
        users.each do |u|
            redis.sadd('users',{login: u.login,password: u.password}.to_json)
        end

        apps.each do |a|
            redis.sadd('applications',{api_key: a.api_key}.to_json)
        end
    end
    
    private ###############################################################################

    def self.clean_redis(redis)
        redis.del('users')
        redis.del('applications')      
    end

    


end

Synchronizer.load
