require_relative '../../../spec/feed/resources/environment'
require_relative '../base'

class DbAccessor::Updater < Db_Accessor::Base


  def self.update_by_id(given_object)
    waited_keys = [:model_name,:attributes]
    if validate(given_object,waited_keys) && valid_attributes_pattern?(given_object[:model_name],given_object[:attributes])
	   var = get_model_name(given_object).update(get_attributes(given_object).keys,get_attributes(given_object).values)
	  return_response(200,"Succesfully updated")
	else
      return_response(400,"Not updated")
    end
    rescue ActiveRecord::RecordNotFound => e
	 return_response(400,"Not updated")
  end


  def self.update_all_objects(given_param,condition="")
    waited_keys = [:model_name,:attributes]
    if validate(given_param,waited_keys) && valid_object_columns?(given_param[:model_name],given_param[:attributes]) && valid_attributes_values?(given_param[:attributes])

	  model_name=Object.const_get(given_param[:model_name])
      list = model_name.all if condition.empty?
      list = model_name.where(condition) if condition.is_a?(Hash) && !condition.empty?
      result = false
      list.each do |o|
        hash = {model_name: model_name.to_s,attributes:{ o.id => given_param[:attributes]}}
        result = update_by_id(hash)
        break if !result
      end
	  result ? return_response(200,"Successfully updated") : return_response(400,"Not updated")
    else
  	  return_response(400,"Not updated")
    end
  end

  private ###################################################################

  def self.get_attributes(given_param)
    given_param[:attributes]
  end

  def self.validate_attributes(given_param)
    given_param.is_a?(Hash) && !given_param.empty?
  end


  def self.valid_fixnum_keys?(keys)
    keys.each do |k|
      if !(k.is_a?(Fixnum))
        return false
        break
      end
    end
    return true
  end

  def self.valid_values_pattern?(values,model_name)
    values.each do |v|
       if !(v.nil?)
         if v.empty? || !(v.is_a?(Hash)) || !valid_object_columns?(model_name,v) || !valid_attributes_values?(v)
         return false
         break
         end
       else
         return false
         break
       end
    end
    return true
  end

  def self.valid_attributes_pattern?(model_name,attributes)
    keys = attributes.keys
    values = attributes.values
    if valid_fixnum_keys?(keys) && valid_values_pattern?(values,model_name)
      return true
    end
  end

  def self.validate(param,waited_keys)
    param.is_a?(Hash) && valid_keys?(param,waited_keys) && is_model?(param[:model_name]) && validate_attributes(param[:attributes]) && !validate_argument(param)
  end

end
